SystemOrganization addCategory: #Proves!

Object subclass: #Pasta
	instanceVariableNames: 'moneda quantitat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proves'!

!Pasta class methodsFor: 'as yet unclassified' stamp: 'David 9/14/2012 16:03'!
moneda: unString quantitat: unInteger
	^ self new moneda: unString; quantitat: unInteger.
	! !

!Pasta methodsFor: 'as yet unclassified' stamp: 'David 9/14/2012 16:05'!
+ unaPasta
	self moneda = unaPasta moneda
		ifTrue: [^ (self quantitat + unaPasta quantitat) euro]
		ifFalse:[^ self error: 'No es poden sumar monedes diferents'].
! !

!Pasta methodsFor: 'as yet unclassified' stamp: 'David 9/14/2012 15:58'!
= unaPasta
	^ self moneda = unaPasta moneda and: [self quantitat = unaPasta quantitat ].
	
	! !

!Pasta methodsFor: 'accessing' stamp: 'David 9/14/2012 15:55'!
moneda

	^ moneda! !

!Pasta methodsFor: 'accessing' stamp: 'David 9/14/2012 15:55'!
moneda: anObject

	moneda := anObject! !

!Pasta methodsFor: 'accessing' stamp: 'David 9/14/2012 15:55'!
quantitat

	^ quantitat! !

!Pasta methodsFor: 'accessing' stamp: 'David 9/14/2012 15:55'!
quantitat: anObject

	quantitat := anObject! !

!Integer methodsFor: '*Proves' stamp: 'David 9/14/2012 16:04'!
euro
	^Pasta moneda:'EUR' quantitat: self.! !

TestCase subclass: #PastaTest
	instanceVariableNames: 'eur5 eur10 eur20'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proves'!

!PastaTest methodsFor: 'as yet unclassified' stamp: 'David 9/14/2012 16:06'!
setUp
	eur5 := 5 euro.
	eur10 := 10 euro.
	eur20 := 20 euro. 
	! !

!PastaTest methodsFor: 'as yet unclassified' stamp: 'David 9/14/2012 16:06'!
testIguals
	self assert: eur5 = eur5.
	self assert: eur5 = 5 euro.
	self assert: eur5 ~= eur10.! !

!PastaTest methodsFor: 'as yet unclassified' stamp: 'David 9/14/2012 16:02'!
testSuma
	self assert: eur5 + eur5 = eur10.
	self assert: eur10 + eur10 = eur20.
	self assert: eur20 = (eur5 + eur5 + eur5 + eur5).
	! !
